



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>记录一次bug解决过程：resultType和手动开启事务</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">记录一次bug解决过程：resultType和手动开启事务</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 21:27:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、总结</strong></p>
<p><strong>二、BUG描述：MyBatis中resultType使用</strong></p>
<p><strong>　　MyBatis中的resultType类似于入参：parameterType。先看IDCM项目中的实际使用案例代码，如下：</strong></p>
<div>
<pre class="prettyprint linenums">// List&lt;Integer&gt; orderIds = assetBeanMapperExt.getOrderIdsByParentIds(SqlStringUtil.formatInStr(logisticsOrder.getParentIds()));</pre>
</div>
<p><strong>　　我们的目的是通过*Ext层直接返回一个list，list中有我们所需要操纵的数据。logisticsOrder.getParentIds()是前端传入的String类型的id字符串，用逗号或者封号分隔，这里，我们用工具类SqlStringUtil来处理它：</strong></p>
<div>
<pre class="prettyprint linenums">package com.alibaba.tboss.workorder.util;<br />
public class SqlStringUtil {

    private final static String replaceChar_comma     = ",";<br />
    private final static String replaceChar_semicolon = ";";

    // 格式化多个key值查询<br />
    public static String formatInStr(String queryStr) {<br />
        return queryInStr(sliptQueryStr(queryStr));<br />
    }

    // 返回sql查询中的in集合<br />
    public static String queryInStr(String[] queryStrs) {<br />
        if (null == queryStrs || 0 == queryStrs.length) return null;<br />
        StringBuffer buf = new StringBuffer();<br />
        for (int i = 0; i &lt; queryStrs.length; i++) {<br />
            if (i != 0) buf.append(",");<br />
            buf.append("'").append(queryStrs[i]).append("'");<br />
        }<br />
        return buf.toString();<br />
    }

    // 查询字符串分割字符串数组<br />
    public static String[] sliptQueryStr(String queryStr) {<br />
        if (null == queryStr || "".equals(queryStr.trim())) return null;<br />
        queryStr = queryStr.replaceAll(SqlStringUtil.replaceChar_comma, " ").replaceAll(replaceChar_semicolon, " ");<br />
        return queryStr.split("\\s+");<br />
    }<br />
}</pre>
</div>
<p><strong>上面的代码是将web端传入的字符串id，拼接成SQL中的字符串，采用${}替换符，将结果直接拼接到SQL语句中，完成SQL语句的查询。</strong></p>
<div>
<pre class="prettyprint linenums">// List&lt;Integer&gt; getOrderIdsByParentIds(String parentIds);</pre>
</div>
<p><strong>在*MapperExt.java中定义了上述方法后，我们在*MapperExt.xml中的代码如下：</strong></p>
<div>
<pre class="prettyprint linenums">    &lt;select id="getOrderIdsByParentIds" parameterType="java.lang.String" resultType="java.lang.Integer"&gt;<br />
    　　SELECT<br />
        　　DISTINCT order_id<br />
    　　FROM<br />
        　　idc_asset_list<br />
    　　WHERE<br />
        　　is_deleted = 'n'<br />
    　　AND parent_order_id IN (${_parameter})<br />
    &lt;/select&gt;</pre>
</div>
<p><strong>注意我们这里的传入参数是String，传出参数是Integer类型，由于是多个数据，所以用List来接收返回的数据。特别地，当有多个参数的时候，我们可以使用resultType="java.util.HashMap"。实例如下：</strong></p>
<div>
<pre class="prettyprint linenums">    /**<br />
     *<br />
    * @Title: getAllPermissions<br />
    * @Description: 获取所有的权限<br />
    * @author： liupeng.lp@alibaba-inc.com<br />
    * @Date: 2014年5月12日<br />
     */<br />
    @Override<br />
    public DataResult&lt;Map&lt;String, Object&gt;&gt; getAllPermissions(<br />
            PagePara pagePara,<br />
            String permission_name) {<br />
        Map&lt;String, Object&gt; _map_result = new HashMap&lt;String, Object&gt;();<br />
        if(pagePara == null){<br />
            pagePara = new PagePara();<br />
            pagePara.setSkip(0);<br />
            pagePara.setTake(10);<br />
        }<br />
        _map_result.put("begin", pagePara.getSkip());<br />
        _map_result.put("length", pagePara.getTake());

        if(!StringUtil.isBlank(permission_name)){<br />
            _map_result.put("permission_name", permission_name.trim());<br />
        }<br />
        DataResult&lt;Map&lt;String, Object&gt;&gt; dataResult = new DataResult&lt;Map&lt;String, Object&gt;&gt;();<br />
        List&lt;Map&lt;String, Object&gt;&gt; dataRes = appPermissionMapperExt.getAllPermissions(_map_result);<br />
        int count = appPermissionMapperExt.countAllPermissions(_map_result);<br />
        dataResult.setCount(count);<br />
        dataResult.setData(dataRes);<br />
        return dataResult;<br />
    }</pre>
</div>
<p><strong>其中关键代码：List&lt;Map&lt;String, Object&gt;&gt; dataRes = appPermissionMapperExt.getAllPermissions(_map_result);传入一个map结构，输出一个map结构的数据。其*MapperExt.xml层代码如下：</strong></p>
<div>
<pre class="prettyprint linenums">&lt;SELECT id = "getAllPermissions" parameterType = "java.util.HashMap" resultType = "java.util.HashMap" &gt; <br />　　SELECT<br />
        p.id,<br />
        p.res_type AS permission_type,<br />
        p.res_name AS permission_name<br />
    FROM<br />
        app_permission AS p<br />
    WHERE<br />
        p.is_deleted = 'n'<br />
    &lt;IF test = "permission_name!=null" &gt;<br />
        AND p.res_name LIKE CONCAT('%', #{permission_name}, '%')<br />
    &lt;/IF &gt;<br />
    ORDER BY<br />
        CONVERT (p.res_name USING gbk)<br />
    LIMIT #{begin},#{length}<br />
&lt;/SELECT&gt;</pre>
</div>
<p><strong>值得注意的是：resultType为HashMap类型，使用了List&lt;Map&lt;String,Object&gt;&gt;来接收。此外，对于排序：数据库中存储res_name的字段采用的是utf8字符集，需要在排序的时候对字段进行转码，转码方式CONVERT (p.res_name USING gbk)。</strong></p>
<p><strong>三、BUG描述：标准的列表页查询代码如何写</strong></p>
<p><strong>　　业务逻辑层的实现如下：</strong></p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 分页获取工单列表<br />
     *<br />
     * @return<br />
     */<br />
    @Override<br />
    public DataResult&lt;WorkOrderMain&gt; queryOrderPagination(WorkOrderMain orderMain, PagePara pagePara) {<br />
        DataResult&lt;WorkOrderMain&gt; dr = new DataResult&lt;WorkOrderMain&gt;();<br />
        try {<br />
            Map&lt;String, Object&gt; queryPara = getQueryPara(orderMain, pagePara);

            int count = assetUpDownMapperExt.selectAssetUpDownCnt(queryPara);<br />
            List&lt;WorkOrderMain&gt; list = null;<br />
            if (count &gt; 0) {<br />
                list = assetUpDownMapperExt.selectAssetUpDownOrder(queryPara);<br />
                if (null != list) {<br />
                    AssetUpDownOrderUtil.transValueForPage(list);<br />
                    AssetUpDownOrderUtil.setWorkOrderSla(list);<br />
                    AssetUpDownOrderUtil.setShowValue(list);<br />
                }

            } else {<br />
                list = new ArrayList&lt;WorkOrderMain&gt;();<br />
            }<br />
            dr.setData(list);<br />
            dr.setCount(count);<br />
        } catch (Exception e) {<br />
            logger.error(" WorkOrderUpDownBoImpl_queryOrderPagination_error [orderMain={}]:",<br />
                         JSON.toJSON(orderMain).toString(), e);<br />
            throw new ServiceException(ErrorCode.Query_Error, e);<br />
        }<br />
        return dr;<br />
    }</pre>
</div>
<p><strong>　　先count，然后再select，接着对查询出来的数据转义。对于*MapperExt中的查询最好共用一个where来查询，如下：</strong></p>
<div>
<pre class="prettyprint linenums">    &lt;select id="selectAssetUpDownCnt" parameterType="java.util.HashMap" resultType="java.lang.Integer"&gt;<br />
        select count(t.id)<br />
        &lt;include refid="page_WhereSql"/&gt;<br />
    &lt;/select&gt;

    &lt;select id="selectAssetUpDownOrder" parameterType="java.util.HashMap" resultMap="assetUpDownMap"&gt;<br />
        select t.id, t.title, t.category,t.order_device_type, t.subject, t.demander, t.is_atomic, t.atomic_id, t.operationer,<br />
               t.operation_role, t.state, t.sub_state, t.expect_time, t.sla, t.evaluation, t.creator, t.create_source,<br />
               t.source_key, t.gmt_create, t.modifier, t.gmt_modified, t.is_deleted, t.remark, t.parent_id,<br />
               t.asset_total,t.sla_standard,t.sla_unit,t.effective_date,t.is_timeout,t.statement_date,t.finish_asset_total,t.identify_type,<br />
               a.updown_id, a.asset_type, a.opt_type, a.take_over_time,a.site,a.site_name<br />
            &lt;include refid="page_WhereSql"/&gt;<br />
            order by t.gmt_create desc<br />
            limit #{begin},#{length}<br />
    &lt;/select&gt;

    &lt;sql id="page_WhereSql"&gt;<br />
        from idc_work_order_main t , idc_asset_updown a<br />
        where t.atomic_id =a.atomic_id and<br />
            (<br />
                &lt;if test="showAll!=null"&gt;<br />
                    ( t.creator = #{appUserId} and t.state = 'created') or (t.creator != #{appUserId} and t.state != 'created')<br />
                &lt;/if&gt;<br />
                &lt;if test="showAll==null"&gt;<br />
                    t.creator = #{appUserId}  or t.operationer = #{workNo}<br />
                    &lt;if test="sites!=null"&gt;<br />
                        or( t.site in (${sites}) and t.state != 'created')<br />
                    &lt;/if&gt;<br />
                &lt;/if&gt;<br />
            )<br />
        &lt;if test = "title!=null"&gt;<br />
            and t.title like CONCAT('%', #{title}, '%')<br />
        &lt;/if&gt;<br />
        &lt;if test = "startTime!=null"&gt;<br />
            and t.effective_date &amp;gt;= CONCAT(#{startTime},' 00:00:00')<br />
        &lt;/if&gt;<br />
        &lt;if test = "endTime!=null"&gt;<br />
            and t.effective_date &amp;lt;= CONCAT(#{endTime},' 23:59:59')<br />
        &lt;/if&gt;<br />
        &lt;if test = "queryIds!=null" &gt;<br />
            and t.id in (${queryIds})<br />
        &lt;/if&gt;<br />
        &lt;if test = "state!=null"&gt;<br />
            and (t.state =#{state} or t.sub_state =#{state})<br />
        &lt;/if&gt;<br />
        &lt;if test ="isTimeout!=null"&gt;<br />
            and t.is_timeout =#{isTimeout}<br />
        &lt;/if&gt;<br />
        &lt;if test ="evaluation!=null"&gt;<br />
            and t.evaluation =#{evaluation}<br />
        &lt;/if&gt;<br />
        &lt;if test="siteName!=null"&gt;<br />
            and a.site_name = #{siteName}<br />
        &lt;/if&gt;<br />
        &lt;if test ="assetType!=null"&gt;<br />
            and a.asset_type =#{assetType}<br />
        &lt;/if&gt;<br />
        &lt;if test ="optType!=null"&gt;<br />
            and a.opt_type =#{optType}<br />
        &lt;/if&gt;<br />
        &lt;if test ="orderDeviceType!=null"&gt;<br />
            and t.order_device_type=#{orderDeviceType}<br />
        &lt;/if&gt;<br />
        &lt;if test ="parentId!=null"&gt;<br />
            and t.parent_id=#{parentId}<br />
        &lt;/if&gt;<br />
        &lt;if test = "sourceKey!=null"&gt;<br />
            and t.source_key in (${sourceKey})<br />
        &lt;/if&gt;<br />
        &lt;if test = "identifyType !=null and identifyType !=''"&gt;<br />
            and t.identify_type =#{identifyType}<br />
        &lt;/if&gt;<br />
        and t.is_deleted ='n'<br />
        and t.subject='assetUpdown'<br />
    &lt;/sql&gt;</pre>
</div>
<p><strong>四、Spring手动开启事务</strong></p>
<p><strong>　　手动控制事务在项目IDCM中的使用如下，首先在配置文件datasource.xml中做出如下配置：</strong></p>
<div>
<pre class="prettyprint linenums">    &lt;bean id="transactionManager"<br />
        class="org.springframework.jdbc.datasource.DataSourceTransactionManager"&gt;<br />
    &lt;/bean&gt;

    &lt;tx:annotation-driven transaction-manager="transactionManager" /&gt;</pre>
</div>
<p><strong>　　此外，该配置文件还配置了其他信息，如下：</strong></p>
<div>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
 &lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
     xmlns:context="http://www.springframework.org/schema/context"<br />
     xmlns:aop="http://www.springframework.org/schema/aop"<br />
     xmlns:tx="http://www.springframework.org/schema/tx"<br />
     xsi:schemaLocation="<br />
     http://www.springframework.org/schema/beans<br />
     http://www.springframework.org/schema/beans/spring-beans-3.0.xsd<br />
     http://www.springframework.org/schema/context<br />
     http://www.springframework.org/schema/context/spring-context-3.0.xsd<br />
     http://www.springframework.org/schema/aop<br />
     http://www.springframework.org/schema/aop/spring-aop-3.0.xsd<br />
     http://www.springframework.org/schema/tx<br />
     http://www.springframework.org/schema/tx/spring-tx-3.0.xsd"<br />
     default-autowire="byName"&gt;

     &lt;bean id="dataSource" class="com.taobao.tddl.jdbc.group.TGroupDataSource" init-method="init"&gt;<br />
         &lt;property name="appName" value="IDCM_APP"/&gt;<br />
         &lt;property name="dbGroupKey" value="IDCM_GROUP"/&gt;<br />
     &lt;/bean&gt;

     &lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
                 &lt;property name="mapperLocations" value="classpath*:com/**/dal/**/*Mapper*.xml" /&gt;<br />
        &lt;property name="dataSource" ref="dataSource" /&gt;<br />
         &lt;property name="typeAliasesPackage" value="com.alibaba.***.dal" /&gt;<br />
     &lt;/bean&gt;

     &lt;bean class="org.mybatis.spring.mapper.MapperScannerConfigurer"&gt;<br />
             &lt;property name="annotationClass" value="javax.annotation.Resource"&gt;&lt;/property&gt;<br />
         &lt;property name="basePackage" value="com.alibaba.***.dal.***.mapper,com.alibaba.***.dal.***.***.mapper" /&gt;<br />
     &lt;/bean&gt;

     &lt;bean id="transactionManager"<br />
         class="org.springframework.jdbc.datasource.DataSourceTransactionManager"&gt;<br />
     &lt;/bean&gt;

     &lt;tx:annotation-driven transaction-manager="transactionManager" /&gt;

     &lt;context:annotation-config /&gt;<br />
         &lt;tx:advice id="defaultTxAdvice"&gt;<br />
         &lt;tx:attributes&gt;<br />
             &lt;tx:method name="*" rollback-for="Exception" /&gt;<br />
         &lt;/tx:attributes&gt;<br />
     &lt;/tx:advice&gt;

     &lt;aop:config&gt;<br />
         &lt;aop:pointcut id="ao_bo"<br />
             expression="(execution(* *..*BoImpl.*(..))) or ( execution(* *..*AoImpl.*(..)) and ( not execution(* *..*AoImpl.mtx_*(..)) ) )" /&gt;<br />
         &lt;aop:advisor pointcut-ref="ao_bo" advice-ref="defaultTxAdvice" /&gt;<br />
     &lt;/aop:config&gt;

     &lt;context:component-scan base-package="com.alibaba.tboss.biz" /&gt;

 &lt;/beans&gt;</pre>
</div>
<p>datasource.xml配置文件</p></div>
<p><strong>　　再需要使用手动事务的地方，使用方式如下：（事务的name不需要配置，前后约定一致就好）</strong></p>
<div>
<pre class="prettyprint linenums">import org.springframework.jdbc.datasource.DataSourceTransactionManager;<br />
import org.springframework.jdbc.datasource.DataSourceTransactionManager;<br />
import org.springframework.transaction.TransactionDefinition;<br />
import org.springframework.transaction.TransactionStatus;<br />
import org.springframework.transaction.support.DefaultTransactionDefinition;

public class TransactionManagerTest{<br />
    @Autowired<br />
    DataSourceTransactionManager                      transactionManager;

    private static final DefaultTransactionDefinition assetUpdateTx         = new DefaultTransactionDefinition();<br />
    static {<br />
        assetUpdateTx.setName("assetUpdateTx");<br />
        assetUpdateTx.setPropagationBehavior(TransactionDefinition.PROPAGATION_REQUIRES_NEW);<br />
    }

    //测试方法<br />
    public void test() {

        // 单独开启事务, 提交数据库<br />
        TransactionStatus status = transactionManager.getTransaction(assetUpdateTx);

        try{<br />
            //TODO 业务逻辑<br />
        } catch (Exception e) {<br />
            logger.error("transactionManager-updateAssetList :", e.getMessage(), e);<br />
            transactionManager.rollback(status);<br />
            throw new ServiceException("更新数据失败");<br />
        }<br />
        transactionManager.commit(status);<br />
    }<br />
}</pre>
</div>
<p><strong>五、</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvg11qx.html">网页mp3语音展示，点击图片放大，点击图片跳转链接，调表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/495j31mq.html">epoll里面mmap释疑</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k24038.html">Redis从基础命令到实战之字符串类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1g0yzq.html">jQuery&period;proxy&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v7omn8.html">ECharts开始</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yze4jq.html">css设置透明度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd2x1mq.html">Golang哲学思想</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzd30q.html">Leap Years</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okp7y9.html">安卓百度地图开发so文件引用失败问题研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meelp0q.html">centos7关闭防火墙&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnl309.html">ecos资源探测器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5gly8.html">AutoItLibrary安装报错（robotframework）解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me5od6q.html">C&num; NuGet包管理命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me04y2q.html">centos7使用kubeadm安装部署kubernetes 1&period;14</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y05yn8.html">Caused by&colon; java&period;lang&period;NoSuchMethodError&colon; org&period;apache&period;poi&period;hssf&period;usermodel&period;HSSFCell&period;setEncoding&lpar;S&rpar;V</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jgj6jq.html">logstash 抓取IIS日志文件写入Elasticsearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25x7dwq.html">mybatis 二级缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o130y5q.html">对数据进行GZIP压缩或解压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2oe419.html">Nginx的介绍以及编译安装详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/96014y39.html">Windows窗口消息大全</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qwl7397.html">来自于微信小程序的一封简讯</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zrr3qy.html">原生JavaScript实现hasClass、addClass、removeClass、toggleClass</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw0nl97.html">Express 教程 01 - 入门教程之经典的Hello World</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlke08o.html">kvm 使用入门详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mwp6qk.html">Bluemix中国版体验（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwwmzq7.html">一步步开发自己的博客  &period;NET版 剧终篇（6、响应式布局 和 自定义样式）</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwxe8o.html">&lbrack;DeviceOne开发&rsqb;-do&lowbar;LinearLayout组件使用技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ol358z.html">Spring Boot -- 启动彩蛋</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvnrx9x.html">有关&OpenCurlyDoubleQuote;数据统计&rdquo;的一些概念 -- PV UV VV IP跳出率等</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvnm19x.html">EF操作MySql</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
